package co.yixiang.yshop.module.member.service.burypoint;

import java.util.*;
import javax.validation.*;

import co.yixiang.yshop.module.member.controller.admin.burypoint.vo.*;
import co.yixiang.yshop.module.member.dal.dataobject.burypoint.BuryPointDO;
import co.yixiang.yshop.framework.common.pojo.PageResult;
import co.yixiang.yshop.module.member.dal.dataobject.burypoint.TrendChartRespVO;

/**
 * 埋点 Service 接口
 *
 * @author admin
 */
public interface BuryPointService {

    /**
     * 创建埋点
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createBuryPoint(@Valid BuryPointCreateReqVO createReqVO);

    /**
     * 更新埋点
     *
     * @param updateReqVO 更新信息
     */
    void updateBuryPoint(@Valid BuryPointUpdateReqVO updateReqVO);

    /**
     * 删除埋点
     *
     * @param id 编号
     */
    void deleteBuryPoint(Long id);

    /**
     * 获得埋点
     *
     * @param id 编号
     * @return 埋点
     */
    BuryPointDO getBuryPoint(Long id);

    /**
     * 获得埋点列表
     *
     * @param ids 编号
     * @return 埋点列表
     */
    List<BuryPointDO> getBuryPointList(Collection<Long> ids);

    /**
     * 获得埋点分页
     *
     * @param pageReqVO 分页查询
     * @return 埋点分页
     */
    PageResult<BuryPointDO> getBuryPointPage(BuryPointPageReqVO pageReqVO);

    /**
     * 获得埋点列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 埋点列表
     */
    List<BuryPointDO> getBuryPointList(BuryPointExportReqVO exportReqVO);

    List<TrendChartRespVO> getTrendChart();

}
